Unit ASK8C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AR01C_p, AR02C_p, ASK5C_p;

procedure ASK8C(var A :Array of Complex; var X :Array of Complex;
                var R :Array of Complex; M :Integer; L :Integer;
                K :Integer);

implementation

procedure ASK8C(var A :Array of Complex; var X :Array of Complex;
                var R :Array of Complex; M :Integer; L :Integer;
                K :Integer);
var
I,J,MA,ML,MX,M1 :Integer;
PII,RK :Real;
const
SYS003 :Real = 6.2831853071795864769252867665590;
label
_1,_2;
begin

{  ****************************************************************** C }
{                                                                     C }
{  ------------------------  HAHAEHE  ---------------------------- C }
{                                                                     C }
{       PEEHE CCTEM HEHX AEPAECKX YPABHEH  A X = B    C }
{       C KETOHO-PKYHTHO MATPE , BCE KETK KOTOPO CYT    C }
{       KETOHO - PKYHTHE MATP C TEEBM KETKAM        C }
{       ( T.E. A - TPEXYPOBHEBA MATPA  CCT - TA ) .              C }
{                                                                     C }
{       OPOHOE OCAHE :                                          C }
{       ( 1 ) E.E.TPTHKOB , O PEEH CCTEM C MATPAM TA     C }
{       TEEBX , B C. CEHH AHA HA OPTPAHE               C }
{       ( BCTEHE METO  HCTPYMEHTAHHE CCTEM )  ,      C }
{       -BO MY , 1978 .                                           C }
{                                                                     C }
{                                                                     C }
{  ---------------------------  METO  ------------------------------ C }
{                                                                     C }
{       MATPA  A  KETOHOO PAMEPA  K * K , C KETKAM PAMEPA    C }
{       ( M*L ) * ( M*L ) , OOHM PEOPAOBAHEM PBOTC K     C }
{       KETOHO - AOHAHO MATPE TEX E PAMEPOB. TEM CAMM    C }
{       PEEHE CXOHO CCTEM C TPEXYPOBHEBO MATPE CCT-TA    C }
{       ( OPKA M*L*K ) CBEEHO K PEEH   K   CCTEM C BYX -     C }
{       YPOBHEBM MATPAM CT-TA ( OPKA  M*L ) .               C }
{                                                                     C }
{                                                                     C }
{  ------------------  K  POPAMMPOBAH  ---------------------- C }
{                                                                     C }
{       OPTPAH                                                       C }
{                                                                     C }
{                                                                     C }
{  -----------------  OPAHA - PAPAOTK  -------------------- C }
{                                                                     C }
{       HAYHO - CCEOBATECK BCTEH EHTP  M  Y ,      C }
{       AOPATOP  CEHHOO  AHAA                              C }
{                                                                     C }
{       APEC :                                                       C }
{       MOCKBA ,117234 , HB MY , AOPATOP CEHHOO AHAA    C }
{                                                                     C }
{  -----------------------  COOBAHE  -------------------------- C }
{                                                                     C }
{       CALL ASK8C(A,X,R,M,L,K)                                       C }
{                                                                     C }
{  -------------------------  APAMETP  ---------------------------- C }
{                                                                     C }
{       A - KOMEKCH OHOMEPH MACCB H  (2M-1)*L*K , B       C }
{           KOTOPOM AAETC MATPA CCTEM COACHO PABAM ,      C }
{           AHHM B ( 1 ) . A MEHHO : MACCB  A  ETC HA   K     C }
{           KYCKOB H  (2M-1)*L . B I-OM KYCKE AAETC KETKA     C }
{           EPBOO YPOBH, BAC I-O KETKO EPBO KETOHO  C }
{           CTPOK CXOHO MATP. AAHE I-O KETK 1-O YPOBH  C }
{           B CBOEM KYCKE OCYECTBETC CEYM OPAOM :          C }
{           COOTBETCTBY KYCOK ETC HA  L  CEMEHTOB H      C }
{           2M-1 . B J-OM CEMEHTE, J = 1,...,L ,ACBAETC KETKA  C }
{           2-O YPOBH, BAC J-O KETKO EPBO KETOHO     C }
{           CTPOK I-O KETK.P TOM B KA CEMEHT ACBAETC C }
{           EPBA CTPOKA  BCE A HE EMEHT EPBOO CTOA     C }
{           HAHA CO BTOPOO COOTBETCTBYE KETK 2-O YPOBH .   C }
{                                                                     C }
{       X - KOMEKCH OHOMEPH MACCB H  M*L*K , B KOTOPOM    C }
{           AAETC PABA ACT . HA BXOE OPOPAMM B  X       C }
{           OYAETC PEEHE .                                      C }
{                                                                     C }
{       R - KOMEKCH OHOMEPH PAO MACCB H MAX(2M,L,K) . C }
{                                                                     C }
{       M - OPOK 3 - O YPOBH . T : E.                      C }
{                                                                     C }
{       L - OPOK 2 - O YPOBH . T : E.                      C }
{                                                                     C }
{       K - OPOK 1 - O YPOBH . T : E.                      C }
{                                                                     C }
{                                                                     C }
{  -----------------  BBAEME  OPOPAMM  --------------------- C }
{                                                                     C }
{       AR01C , AR02C , ASK5C , ASTAC .                               C }
{                                                                     C }
{  ****************************************************************** C }
{                                                                     C }
{                                                                     C }
{                                                                     C }
{                                                                     C }
{  -------------------------  KOHCTAHT  ---------------------------- C }

{       SYS003=6.2831853717958647692528 ( 2 *  ) }


PII := SYS003/K;
M1 := (2*M-1)*L;
MA := M1*(K-1)+1;
ML := M*L;
MX := ML*K;

AR01C(A,R,M1,K,PII);
AR02C(X,R,ML,K,PII);

J := 1;
I := 1;
while ( I<=MA ) do
 begin
  ASK5C(A[I-1],X[J-1],R,M,L);
_1:
  J := J+ML;
  inc(I,M1);
 end;

AR01C(X,R,ML,K,PII);

RK := 1.0/K;
for I:=1 to MX do
 begin
_2:
  X[I-1] := MulC(X[I-1],Cmplx(RK,0.0));
 end;

end;

end.
